org.apache.commons.math3.distribution

## Class BetaDistribution

- java.lang.Object
- - org.apache.commons.math3.distribution.AbstractRealDistribution
  - - org.apache.commons.math3.distribution.BetaDistribution

All Implemented Interfaces:
  java.io.Serializable, RealDistribution

    public class BetaDistribution
    extends AbstractRealDistribution

Implements the Beta distribution.

Since:
  2.0 (changed to concrete class in 3.0)
Version:
  $Id: BetaDistribution.java 1416643 2012-12-03 19:37:14Z tn $
See Also:
  Beta distribution, Serialized Form

### Field Summary

Fields
`private double` `alpha` First shape parameter.
`private double` `beta` Second shape parameter.
`static double` `DEFAULT_INVERSE_ABSOLUTE_ACCURACY` Default inverse cumulative probability accuracy.
`private static long` `serialVersionUID` Serializable version identifier.
`private double` `solverAbsoluteAccuracy` Inverse cumulative probability accuracy.
`private double` `z` Normalizing factor used in density computations.

### Fields inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution

`random, randomData, SOLVER_DEFAULT_ABSOLUTE_ACCURACY`

### Constructor Summary

Constructors
Constructor and Description
`BetaDistribution(double alpha, double beta)` Build a new instance.
`BetaDistribution(double alpha, double beta, double inverseCumAccuracy)` Build a new instance.
`BetaDistribution(RandomGenerator rng, double alpha, double beta, double inverseCumAccuracy)` Creates a β distribution.

### Method Summary

Methods
`double` `cumulativeProbability(double x)` For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`.
`double` `density(double x)` Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`.
`double` `getAlpha()` Access the first shape parameter, `alpha`.
`double` `getBeta()` Access the second shape parameter, `beta`.
`double` `getNumericalMean()` Use this method to get the numerical value of the mean of this distribution.
`double` `getNumericalVariance()` Use this method to get the numerical value of the variance of this distribution.
`protected double` `getSolverAbsoluteAccuracy()` Return the absolute accuracy setting of the solver used to estimate inverse cumulative probabilities.
`double` `getSupportLowerBound()` Access the lower bound of the support.
`double` `getSupportUpperBound()` Access the upper bound of the support.
`boolean` `isSupportConnected()` Use this method to get information about whether the support is connected, i.e.
`boolean` `isSupportLowerBoundInclusive()` Whether or not the lower bound of support is in the domain of the density function.
`boolean` `isSupportUpperBoundInclusive()` Whether or not the upper bound of support is in the domain of the density function.
`private void` `recomputeZ()` Recompute the normalization factor.

### Methods inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution

`cumulativeProbability, inverseCumulativeProbability, probability, probability, reseedRandomGenerator, sample, sample`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### DEFAULT_INVERSE_ABSOLUTE_ACCURACY

    public static final double DEFAULT_INVERSE_ABSOLUTE_ACCURACY

Default inverse cumulative probability accuracy.

Since:
  2.1
See Also:
  Constant Field Values

#### serialVersionUID

    private static final long serialVersionUID

Serializable version identifier.

See Also:
  Constant Field Values

#### alpha

    private final double alpha

First shape parameter.

#### beta

    private final double beta

Second shape parameter.

#### z

    private double z

Normalizing factor used in density computations. updated whenever alpha or beta are changed.

#### solverAbsoluteAccuracy

    private final double solverAbsoluteAccuracy

Inverse cumulative probability accuracy.

### Constructor Detail

#### BetaDistribution

    public BetaDistribution(double alpha,
                    double beta)

Build a new instance.

Parameters:
  `alpha` - First shape parameter (must be positive).
  `beta` - Second shape parameter (must be positive).

#### BetaDistribution

    public BetaDistribution(double alpha,
                    double beta,
                    double inverseCumAccuracy)

Build a new instance.

Parameters:
  `alpha` - First shape parameter (must be positive).
  `beta` - Second shape parameter (must be positive).
  `inverseCumAccuracy` - Maximum absolute error in inverse cumulative probability estimates (defaults to `DEFAULT_INVERSE_ABSOLUTE_ACCURACY`).
Since:
  2.1

#### BetaDistribution

    public BetaDistribution(RandomGenerator rng,
                    double alpha,
                    double beta,
                    double inverseCumAccuracy)

Creates a β distribution.

Parameters:
  `rng` - Random number generator.
  `alpha` - First shape parameter (must be positive).
  `beta` - Second shape parameter (must be positive).
  `inverseCumAccuracy` - Maximum absolute error in inverse cumulative probability estimates (defaults to `DEFAULT_INVERSE_ABSOLUTE_ACCURACY`).
Since:
  3.1

### Method Detail

#### getAlpha

    public double getAlpha()

Access the first shape parameter, `alpha`.

Returns:
  the first shape parameter.

#### getBeta

    public double getBeta()

Access the second shape parameter, `beta`.

Returns:
  the second shape parameter.

#### recomputeZ

    private void recomputeZ()

Recompute the normalization factor.

#### density

    public double density(double x)

Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`. In general, the PDF is the derivative of the `CDF`. If the derivative does not exist at `x`, then an appropriate replacement should be returned, e.g. `Double.POSITIVE_INFINITY`, `Double.NaN`, or the limit inferior or limit superior of the difference quotient.

Parameters:
  `x` - the point at which the PDF is evaluated
Returns:
  the value of the probability density function at point `x`

#### cumulativeProbability

    public double cumulativeProbability(double x)

For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`. In other words, this method represents the (cumulative) distribution function (CDF) for this distribution.

Parameters:
  `x` - the point at which the CDF is evaluated
Returns:
  the probability that a random variable with this distribution takes a value less than or equal to `x`

#### getSolverAbsoluteAccuracy

    protected double getSolverAbsoluteAccuracy()

Return the absolute accuracy setting of the solver used to estimate inverse cumulative probabilities.

Overrides:
  `getSolverAbsoluteAccuracy` in class `AbstractRealDistribution`
Returns:
  the solver absolute accuracy.
Since:
  2.1

#### getNumericalMean

    public double getNumericalMean()

Use this method to get the numerical value of the mean of this distribution. For first shape parameter `alpha` and second shape parameter `beta`, the mean is `alpha / (alpha + beta)`.

Returns:
  the mean or `Double.NaN` if it is not defined

#### getNumericalVariance

    public double getNumericalVariance()

Use this method to get the numerical value of the variance of this distribution. For first shape parameter `alpha` and second shape parameter `beta`, the variance is `(alpha * beta) / [(alpha + beta)^2 * (alpha + beta + 1)]`.

Returns:
  the variance (possibly `Double.POSITIVE_INFINITY` as for certain cases in `TDistribution`) or `Double.NaN` if it is not defined

#### getSupportLowerBound

    public double getSupportLowerBound()

Access the lower bound of the support. This method must return the same value as `inverseCumulativeProbability(0)`. In other words, this method must return

`inf {x in R | P(X <= x) > 0}`.

The lower bound of the support is always 0 no matter the parameters.

Returns:
  lower bound of the support (always 0)

#### getSupportUpperBound

    public double getSupportUpperBound()

Access the upper bound of the support. This method must return the same value as `inverseCumulativeProbability(1)`. In other words, this method must return

`inf {x in R | P(X <= x) = 1}`.

The upper bound of the support is always 1 no matter the parameters.

Returns:
  upper bound of the support (always 1)

#### isSupportLowerBoundInclusive

    public boolean isSupportLowerBoundInclusive()

Whether or not the lower bound of support is in the domain of the density function. Returns true iff `getSupporLowerBound()` is finite and `density(getSupportLowerBound())` returns a non-NaN, non-infinite value.

Returns:
  true if the lower bound of support is finite and the density function returns a non-NaN, non-infinite value there

#### isSupportUpperBoundInclusive

    public boolean isSupportUpperBoundInclusive()

Whether or not the upper bound of support is in the domain of the density function. Returns true iff `getSupportUpperBound()` is finite and `density(getSupportUpperBound())` returns a non-NaN, non-infinite value.

Returns:
  true if the upper bound of support is finite and the density function returns a non-NaN, non-infinite value there

#### isSupportConnected

    public boolean isSupportConnected()

Use this method to get information about whether the support is connected, i.e. whether all values between the lower and upper bound of the support are included in the support. The support of this distribution is connected.

Returns:
  `true`